package com.company.j161ui.app;

import org.springframework.security.web.util.matcher.*;
import org.springframework.stereotype.Component;
import org.springframework.web.filter.OncePerRequestFilter;

import javax.servlet.*;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;


@Component
public class SessionMaxInactiveIntervalFilter extends OncePerRequestFilter {

    private final RequestMatcher notTokenRequestMatcher =
            new NegatedRequestMatcher(
                    new OrRequestMatcher(//specify requests which leave orphaned sessions
                            new AntPathRequestMatcher("/oauth/token"),
                            new AntPathRequestMatcher("/rest/**")));

    @Override
    protected void doFilterInternal(HttpServletRequest request, HttpServletResponse response, FilterChain filterChain) throws ServletException, IOException {
        filterChain.doFilter(request, response);
        request.getSession().setMaxInactiveInterval(60);//specify desired session expiration time
    }

    @Override
    protected boolean shouldNotFilter(HttpServletRequest request) {
        return notTokenRequestMatcher.matches(request);
    }
}