package com.company.j161ui.app;

import io.jmix.audit.UserSessions;
import io.jmix.core.session.SessionData;
import org.springframework.beans.factory.ObjectProvider;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Service;

import javax.annotation.Nullable;
import java.util.stream.Collectors;

@Service("sample_TestBean")
public class TestBean {
    private final UserSessions userSessions;
    private final ObjectProvider<SessionData> sessionDataProvider;

    public TestBean(UserSessions userSessions, ObjectProvider<SessionData> sessionData) {
        this.userSessions = userSessions;
        this.sessionDataProvider = sessionData;
    }

    public String test(@Nullable String testVal) {
        String sessions = userSessions.sessions()
                .map(session -> session.getSessionId() + "|" + session.getPrincipalName())
                .collect(Collectors.joining("\n"));
        String oldVal = (String) sessionDataProvider.getObject().getAttribute("TEST");
        if (testVal != null) {
            sessionDataProvider.getObject().setAttribute("TEST", testVal);
        }
        return "User sessions:\n" + sessions + "\n\nSession data:" + oldVal + ((testVal != null) ? "->" + testVal : "");
    }
}